@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
goto endofperl
@rem ';
#!perl
#line 14

############################################
#                                          #
#  The script "ls.bat" is                  #
#                                          #
#  Copyright (C) 2005 by Steffen Beyer.    #
#  All rights reserved.                    #
#                                          #
#                                          #
#  The script "ls.bat" is                  #
#                                          #
#  free software; you can redistribute it  #
#  and/or modify it under the same terms   #
#  as Perl itself.                         #
#                                          #
############################################

use strict;

my($Self,$Item);

$Self = $0; $Self =~ s!^.*[\/\\]!!; $Self =~ s!\.[^\.\/\\]*$!!;

@ARGV = ('.') unless (@ARGV);

foreach $Item (sort map { glob($_) } @ARGV)
{
    List($Item);
}

sub List
{
    my($item) = shift;
    my(@list);

    if (-e $item)
    {
        print "$item\n";
        if (-d $item)
        {
            unless (opendir(ITEM, $item))
            {
                warn "$Self: can't open directory <$item>: $!\n";
                return;
            }
            @list = map { "$item/$_" }
                    sort
                    grep { !/^\.\.?$/ }
                    readdir(ITEM);
            unless (closedir(ITEM))
            {
                warn "$Self: can't close directory <$item>: $!\n";
            }
            foreach $item (sort @list)
            {
                List($item);
            }
        }
    }
    else
    {
        warn "$Self: can't find item <$item>!\n";
    }
}

__END__
:endofperl
