@rem = '--*-Perl-*--
@echo off
if "%OS%" == "Windows_NT" goto WinNT
perl -x -S "%0" %1 %2 %3 %4 %5 %6 %7 %8 %9
goto endofperl
:WinNT
perl -x -S "%0" %*
if NOT "%COMSPEC%" == "%SystemRoot%\system32\cmd.exe" goto endofperl
if %errorlevel% == 9009 echo You do not have Perl in your PATH.
goto endofperl
@rem ';
#!perl
#line 14

############################################
#                                          #
#  The script "wav2mp3.bat" is             #
#                                          #
#  Copyright (C) 2005 by Steffen Beyer.    #
#  All rights reserved.                    #
#                                          #
#                                          #
#  The script "wav2mp3.bat" is             #
#                                          #
#  free software; you can redistribute it  #
#  and/or modify it under the same terms   #
#  as Perl itself.                         #
#                                          #
############################################

use strict;

my($Self,$Dir,$File,@List,$Artist,$Album,$Year,$Genre,$Count,$Title,$Track,$Filename,$Outname,$CMD);

$Self = $0; $Self =~ s!^.*[\/\\]!!; $Self =~ s!\.[^\.\/\\]*$!!;

unless (@ARGV == 2)
{
    die "Usage: $Self <Directory> <Metafile>\n";
}

$Dir = shift;
$File = shift;

unless (opendir(DIR, $Dir))
{
    die "$Self: can't open directory <$Dir>: $!\n";
}
@List = map  { $_->[0] }
        sort { $a->[1] <=> $b->[1] || lc($a->[0]) cmp lc($b->[0]) || $a->[0] cmp $b->[0] }
        map  { if (/^(\d+)/) { [$_,$1] } elsif (/^.*?\D(\d+)\.wav$/i) { [$_,$1] } else { [$_,0] } }
        grep { (-f "$Dir/$_") and /^(?:\d+.*|.*?\D\d+)\.wav$/i }
        readdir(DIR);
unless (closedir(DIR))
{
    warn "$Self: can't close directory <$Dir>: $!\n";
}

$File = "$Dir/$File" if ($Dir ne '.' and $File !~ /[:\/\\]/ and -f "$Dir/$File" and -r _ and -s _);

unless (open(FILE, "<$File"))
{
    die "$Self: can't open file <$File>: $!\n";
}

unless (defined ($Artist = <FILE>))
{
    close(FILE);
    die "$Self: can't find field <Artist>!\n";
}
unless (defined ($Album = <FILE>))
{
    close(FILE);
    die "$Self: can't find field <Album>!\n";
}
unless (defined ($Year = <FILE>))
{
    close(FILE);
    die "$Self: can't find field <Year>!\n";
}
unless (defined ($Genre = <FILE>))
{
    close(FILE);
    die "$Self: can't find field <Genre>!\n";
}

$Artist =~ s!_+! !g;
$Artist =~ s!^\s+!!;
$Artist =~ s!\s+$!!;
$Artist =~ s!\s+! !g;

$Album =~ s!_+! !g;
$Album =~ s!^\s+!!;
$Album =~ s!\s+$!!;
$Album =~ s!\s+! !g;

$Year =~ s!_+! !g;
$Year =~ s!^\s+!!;
$Year =~ s!\s+$!!;
$Year =~ s!\s+! !g;

$Genre =~ s!_+! !g;
$Genre =~ s!^\s+!!;
$Genre =~ s!\s+$!!;
$Genre =~ s!\s+! !g;

$Count = 0;

while (defined($Title = <FILE>) and @List)
{
    $Title =~ s!_+! !g;
    $Title =~ s!^\s+!!;
    $Title =~ s!^\d+[\:\.\s-]*!!;
    $Title =~ s!\s+$!!;
    $Title =~ s!\s*\[[^\[\]]*\]$!!;
    $Title =~ s!\s*\.+[^\.\s\/\\]*$!!;
    $Title =~ s!\s+! !g;

    $Track = sprintf("%02d", ++$Count);

    $Filename = $Dir . '/' . shift(@List);

    $Outname = $Title;
    $Outname =~ s![\/\\\:\*\?\"\<\>\|\s]+!_!g;
    $Outname =~ s!_+(?:-+_+)+!_!g;
    $Outname =~ s!__+!_!g;
    $Outname =~ s!^_+!!;
    $Outname =~ s!_+$!!;
    $Outname = "${Dir}/${Track}_${Outname}.mp3";

    $CMD = 'lame.exe';
    $CMD .= qq( -b 320 -m s -h --add-id3v2);
    $CMD .= qq( --tt "$Title");
    $CMD .= qq( --ta "$Artist");
    $CMD .= qq( --tl "$Album");
    $CMD .= qq( --ty "$Year");
    $CMD .= qq( --tc "");
    $CMD .= qq( --tn "$Track");
    $CMD .= qq( --tg "$Genre");
    $CMD .= qq( "$Filename");
    $CMD .= qq( "$Outname");

    print "\n$CMD\n\n";
    system($CMD);
}

unless (close(FILE))
{
    warn "$Self: can't close file <$File>: $!\n";
}

__END__
:endofperl
